;--- include file created by h2incx v0.99.17, copyright 2005-2006 japheth
;--- source file: C:\Documents and Settings\georgek01wes\Desktop\ASM\Tools\H2INC\BluetoothAPIs.h, last modified: 2/17/2006 9:37
;--- cmdline used for creation: "C:\Documents and Settings\georgek01wes\Desktop\ASM\Tools\H2INC\BluetoothAPIs.h"

;#pragma once 

BLUETOOTH_MAX_NAME_SIZE				EQU	248
BLUETOOTH_MAX_PASSKEY_SIZE			EQU	16
BLUETOOTH_MAX_PASSKEY_BUFFER_SIZE		EQU	( BLUETOOTH_MAX_PASSKEY_SIZE + 1 )

ifdef __cplusplus
	;extern "C"
	;{
endif 

BTH_ADDR typedef QWORD

BLUETOOTH_ADDRESS_STRUCT	struct 
	union
		ullLong	BTH_ADDR ?
		rgBytes	BYTE 6 dup (?)
	ends
BLUETOOTH_ADDRESS_STRUCT	ends

BLUETOOTH_ADDRESS	EQU	<BLUETOOTH_ADDRESS_STRUCT>
BLUETOOTH_NULL_ADDRESS	EQU	0h
BLUETOOTH_FIND_RADIO_PARAMS	struct 
dwSize	DWORD	?
BLUETOOTH_FIND_RADIO_PARAMS	ends

HBLUETOOTH_RADIO_FIND typedef HANDLE
BluetoothFindFirstRadio proto stdcall :ptr BLUETOOTH_FIND_RADIO_PARAMS, :ptr HANDLE
BluetoothFindNextRadio proto stdcall :HBLUETOOTH_RADIO_FIND, :ptr HANDLE
BluetoothFindRadioClose proto stdcall :HBLUETOOTH_RADIO_FIND

BLUETOOTH_RADIO_INFO	struct 
	dwSize	DWORD	?
	address	BLUETOOTH_ADDRESS <>
	szName	WCHAR BLUETOOTH_MAX_NAME_SIZE dup (?)
	ulClassofDevice	DWORD	?
	lmpSubversion	WORD	?
	manufacturer	WORD	?
BLUETOOTH_RADIO_INFO	ends

PBLUETOOTH_RADIO_INFO typedef ptr BLUETOOTH_RADIO_INFO

BluetoothGetRadioInfo proto stdcall :HANDLE, :PBLUETOOTH_RADIO_INFO

BLUETOOTH_DEVICE_INFO_STRUCT	struct 
	dwSize	DWORD	?
	Address	BLUETOOTH_ADDRESS	<>
	ulClassofDevice	DWORD	?
	fConnected	BOOL	?
	fRemembered	BOOL	?
	fAuthenticated	BOOL	?
	stLastSeen	SYSTEMTIME	<>
	stLastUsed	SYSTEMTIME	<>
	szName	WCHAR BLUETOOTH_MAX_NAME_SIZE dup (?)
BLUETOOTH_DEVICE_INFO_STRUCT	ends

BLUETOOTH_DEVICE_INFO	EQU	<BLUETOOTH_DEVICE_INFO_STRUCT>
PBLUETOOTH_DEVICE_INFO typedef ptr BLUETOOTH_DEVICE_INFO

BLUETOOTH_DEVICE_SEARCH_PARAMS	struct 
	dwSize	DWORD	?
	fReturnAuthenticated	BOOL	?
	fReturnRemembered	BOOL	?
	fReturnUnknown	BOOL	?
	fReturnConnected	BOOL	?
	fIssueInquiry	BOOL	?
	cTimeoutMultiplier	BYTE	?
	hRadio	HANDLE	?
BLUETOOTH_DEVICE_SEARCH_PARAMS	ends

HBLUETOOTH_DEVICE_FIND typedef HANDLE
BluetoothFindFirstDevice proto stdcall :ptr BLUETOOTH_DEVICE_SEARCH_PARAMS, :ptr BLUETOOTH_DEVICE_INFO
BluetoothFindNextDevice proto stdcall :HBLUETOOTH_DEVICE_FIND, :ptr BLUETOOTH_DEVICE_INFO
BluetoothFindDeviceClose proto stdcall :HBLUETOOTH_DEVICE_FIND
BluetoothGetDeviceInfo proto stdcall :HANDLE, :ptr BLUETOOTH_DEVICE_INFO
BluetoothUpdateDeviceRecord proto stdcall :ptr BLUETOOTH_DEVICE_INFO
BluetoothRemoveDevice proto stdcall :ptr BLUETOOTH_ADDRESS
BLUETOOTH_COD_PAIRS	struct 
ulCODMask	DWORD	?
pcszDescription	LPWSTR	?
BLUETOOTH_COD_PAIRS	ends

proto_PFN_DEVICE_CALLBACK typedef proto stdcall :LPVOID,:PBLUETOOTH_DEVICE_INFO
PFN_DEVICE_CALLBACK typedef ptr proto_PFN_DEVICE_CALLBACK
BLUETOOTH_SELECT_DEVICE_PARAMS	struct 
dwSize	DWORD	?
cNumOfClasses	DWORD	?
prgClassOfDevices	DWORD	?
pszInfo	LPWSTR	?
hwndParent	HWND	?
fForceAuthentication	BOOL	?
fShowAuthenticated	BOOL	?
fShowRemembered	BOOL	?
fShowUnknown	BOOL	?
fAddNewDeviceWizard	BOOL	?
fSkipServicesPage	BOOL	?
pfnDeviceCallback	PFN_DEVICE_CALLBACK	?
pvParam	LPVOID	?
cNumDevices	DWORD	?
pDevices	PBLUETOOTH_DEVICE_INFO	?
BLUETOOTH_SELECT_DEVICE_PARAMS	ends

BluetoothSelectDevices proto stdcall :ptr BLUETOOTH_SELECT_DEVICE_PARAMS
BluetoothSelectDevicesFree proto stdcall :ptr BLUETOOTH_SELECT_DEVICE_PARAMS
BluetoothDisplayDeviceProperties proto stdcall :HWND, :ptr BLUETOOTH_DEVICE_INFO
BluetoothAuthenticateDevice proto stdcall :HWND, :HANDLE, :ptr BLUETOOTH_DEVICE_INFO, :PWCHAR, :DWORD
BluetoothAuthenticateMultipleDevices proto stdcall :HWND, :HANDLE, :DWORD, :ptr BLUETOOTH_DEVICE_INFO
BLUETOOTH_SERVICE_DISABLE	EQU	00h
BLUETOOTH_SERVICE_ENABLE	EQU	01h
BLUETOOTH_SERVICE_MASK	EQU	( BLUETOOTH_ENABLE_SERVICE  or  BLUETOOTH_DISABLE_SERVICE )
BluetoothSetServiceState proto stdcall :HANDLE, :ptr BLUETOOTH_DEVICE_INFO, :ptr GUID, :DWORD
BluetoothEnumerateInstalledServices proto stdcall :HANDLE, :ptr BLUETOOTH_DEVICE_INFO, :ptr DWORD, :ptr GUID
BluetoothEnableDiscovery proto stdcall :HANDLE, :BOOL
BluetoothIsDiscoverable proto stdcall :HANDLE
BluetoothEnableIncomingConnections proto stdcall :HANDLE, :BOOL
BluetoothIsConnectable proto stdcall :HANDLE
HBLUETOOTH_AUTHENTICATION_REGISTRATION typedef HANDLE
proto_PFN_AUTHENTICATION_CALLBACK typedef proto  :LPVOID,:PBLUETOOTH_DEVICE_INFO
PFN_AUTHENTICATION_CALLBACK typedef ptr proto_PFN_AUTHENTICATION_CALLBACK
BluetoothRegisterForAuthentication proto stdcall :ptr BLUETOOTH_DEVICE_INFO, :ptr HBLUETOOTH_AUTHENTICATION_REGISTRATION, :PFN_AUTHENTICATION_CALLBACK, :PVOID
BluetoothUnregisterAuthentication proto stdcall :HBLUETOOTH_AUTHENTICATION_REGISTRATION
BluetoothSendAuthenticationResponse proto stdcall :HANDLE, :ptr BLUETOOTH_DEVICE_INFO, :LPWSTR

SDP_ELEMENT_DATA	struct 
	type_	DWORD	? ;type_	SDP_TYPE	?
	specificType	DWORD	? ;specificType	SDP_SPECIFICTYPE	?
	union data
	int128	DWORD	? ;int128	SDP_LARGE_INTEGER_16	?
	int64	QWORD	?
	int32	SDWORD	?
	int16	SWORD	?
	int8	CHAR	?
	uint128	DWORD	? ;uint128	SDP_ULARGE_INTEGER_16	?
	uint64	QWORD	?
	uint32	DWORD	?
	uint16	WORD	?
	uint8	BYTE	?
	booleanVal	BYTE	?
	uuid128	GUID	<>
	uuid32	DWORD	?
	uuid16	WORD	?
	struct string
	value	LPBYTE	?
	length_	DWORD	?
ends

struct url
	value	LPBYTE	?
	length_	DWORD	?
	ends
	struct sequence
	value	LPBYTE	?
	length_	DWORD	?
ends

struct alternative
	value	LPBYTE	?
	length_	DWORD	?
	ends
	ends
SDP_ELEMENT_DATA	ends

PSDP_ELEMENT_DATA typedef ptr SDP_ELEMENT_DATA

BluetoothSdpGetElementData proto stdcall :LPBYTE, :DWORD, :PSDP_ELEMENT_DATA
HBLUETOOTH_CONTAINER_ELEMENT typedef HANDLE
BluetoothSdpGetContainerElementData proto stdcall :LPBYTE, :DWORD, :ptr HBLUETOOTH_CONTAINER_ELEMENT, :PSDP_ELEMENT_DATA
BluetoothSdpGetAttributeValue proto stdcall :LPBYTE, :DWORD, :WORD, :PSDP_ELEMENT_DATA
SDP_STRING_TYPE_DATA	struct 
encoding	WORD	?
mibeNum	WORD	?
attributeId	WORD	?
SDP_STRING_TYPE_DATA	ends

PSDP_STRING_TYPE_DATA typedef ptr SDP_STRING_TYPE_DATA

BluetoothSdpGetString proto stdcall :LPBYTE, :DWORD, :PSDP_STRING_TYPE_DATA, :WORD, :PWCHAR, :PULONG
proto_PFN_BLUETOOTH_ENUM_ATTRIBUTES_CALLBACK typedef proto stdcall :DWORD,:LPBYTE,:DWORD,:LPVOID
PFN_BLUETOOTH_ENUM_ATTRIBUTES_CALLBACK typedef ptr proto_PFN_BLUETOOTH_ENUM_ATTRIBUTES_CALLBACK
BluetoothEnumAttributes	EQU	<BluetoothSdpEnumAttributes>
BluetoothSdpEnumAttributes proto stdcall :LPBYTE, :DWORD, :PFN_BLUETOOTH_ENUM_ATTRIBUTES_CALLBACK, :LPVOID
ifdef __cplusplus
;}
endif 

;--- errors: 0
;--- end of file ---
