; --- code for list control :: SysListView32

InsertListItem proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD; --- insert list data: list handle, [list text], group ID, image ID, index
InsertListSubItem proto :DWORD, :DWORD, :DWORD, :DWORD; --- insert list sub item: list handle, [node text], list index, column number
InsertGroupList proto :DWORD, :DWORD, :DWORD ; --- add grouping to list: list handle, [group text], group ID
InsertListColumn proto :DWORD, :DWORD, :DWORD, :DWORD ; --- add column to list handle: list handle, [column text], column width, column index

LVGROUP STRUCT
    cbSize 		dd ?
    imask 		dd ?
    pszHeader 	dd ?
    cchHeader 	dd ?
    pszFooter 	dd ?
    cchFooter 	dd ?
    iGroupId 	dd ?
    stateMask 	dd ?
    state 		dd ?
    uAlign 		dd ?
LVGROUP ENDS

LVGROUPMETRICS STRUCT
    cbSize 		dd ?
    imask 		dd ?
    Left 		dd ?
    Top 		dd ?
    Right 		dd ?
    Bottom 		dd ?
    crLeft 		dd ?
    crTop 		dd ?
    crRight 	dd ?
    crBottom	dd ?
    crHeader	dd ?
    crFooter	dd ?
LVGROUPMETRICS ENDS

.const

	LVM_ENABLEGROUPVIEW equ LVM_FIRST + 157

.data
	

.data?
	
	buffer db 256 dup(?) ; --- buffer for text

.code

InsertListItem proc h:DWORD, pText:DWORD, groupID:DWORD, iImage:DWORD, iIndex:DWORD
	
	; --- insert list item into list control
	; --- list handle, list text, group ID, image ID 
	
	local lvi:LVITEM
	
	mov lvi.imask, LVIF_TEXT or LVIF_GROUPID or LVIF_IMAGE
	
	invoke SendMessage,h,LVM_GETITEMCOUNT,0,0			
	
	mov lvi.iItem, eax
	
	mov eax, iImage
	mov lvi.iImage,eax
	mov eax, iIndex
	mov lvi.iItem, eax
	mov eax, groupID
	mov lvi.iGroupId, eax
	mov lvi.iSubItem, 0
	mov eax, [pText]
	mov lvi.pszText,eax
	
	invoke SendMessage,h,LVM_INSERTITEM,0,addr lvi
	
	xor eax, eax
	Ret
InsertListItem EndP

InsertListSubItem proc h:DWORD, pText:DWORD, iIndex:DWORD, iCol:DWORD
	
	; --- insert sub item in list control
	; --- list handle, subitem text, list item index, subitem column ID
	
	local lvi:LVITEM
	
	mov lvi.imask, LVIF_TEXT
	mov eax, iIndex
	mov lvi.iItem, eax
	mov eax, iCol
	mov lvi.iSubItem,eax
	
	mov eax, [pText]
	mov lvi.pszText, eax
	
	invoke SendMessage,h,LVM_SETITEM,0,addr lvi
	 
	xor eax, eax
	Ret
InsertListSubItem EndP

InsertGroupList proc h:DWORD, pGroup:DWORD, iID:DWORD
	
	; --- insert group into list control
	; --- list handle, goup text, group ID
	
	local lvg:LVGROUP
	
	Invoke RtlZeroMemory,ADDR lvg,SizeOf LVGROUP	
	invoke SendMessage,h,LVM_ENABLEGROUPVIEW,TRUE,NULL
	
	mov lvg.cbSize, SizeOf lvg
	mov lvg.imask, LVGF_ALIGN or LVGF_GROUPID or LVGF_HEADER or LVGF_STATE or LVGF_NONE
	;mov lvg.uAlign, LVGA_HEADER_LEFT or LVGA_FOOTER_LEFT
	;mov lvg.stateMask, 0
	mov lvg.state, LVGS_NORMAL
	
	mov eax, [pGroup]
	
	invoke MultiByteToWideChar,0,0,eax,-1, addr buffer, lengthof buffer
	
	mov lvg.pszHeader, offset buffer
	mov lvg.cchHeader, LengthOf buffer
	mov eax, iID
	mov lvg.iGroupId,eax
		
	invoke SendMessage,h,LVM_INSERTGROUP,-1,addr lvg
	
	xor eax, eax
	Ret
InsertGroupList EndP

InsertListColumn proc h:DWORD, pText:DWORD, iWidth:DWORD, iIndex:DWORD
	
	; --- insert column in list control
	; --- list handle, column text, column width, column index
	
	local lvc:LVCOLUMN
	
	mov lvc.imask, LVCF_TEXT or LVCF_WIDTH
	mov eax, [pText]
	mov lvc.pszText, eax
	mov eax, iWidth
	mov lvc.lx, eax
	
	invoke SendMessage,h,LVM_INSERTCOLUMN,iIndex , addr lvc
	
	xor eax, eax
	Ret
InsertListColumn EndP