.486 					
.model flat, stdcall 	
option casemap: none 	

include windows.inc
include user32.inc
include kernel32.inc
include comctl32.inc
include gdi32.inc
include BluetoothAPIs.INC
include irprops.inc

includelib user32.lib
includelib kernel32.lib
includelib comctl32.lib
includelib gdi32.lib
includelib irprops.lib

include ListView-lib.asm

DlgProc 					proto :DWORD,:DWORD,:DWORD,:DWORD ; --- main dialog procedure
DoImageList 				proto ; --- image list for list view
ErrMsg 						proto :DWORD, :DWORD, :DWORD ; --- standard error message for GetLast and WsaGetLast
FindDevices 				proto ; --- find BT devices

.const
	
	IDD_MAIN 					equ 1001
	IDC_LISTVIEW 				equ 1002
	ICO1 						equ 2000	

.data?

	hInstance 					dd ?
	hList 						dd ?
	hBitmap 					dd ?
	hImageList 					dd ?
	hDlg 						dd ?
	hDevice						dd ?
	hLib						dd ?
	
.data

	szAppName 					db 'My App',0
	szBluetooth 				db 'Bluetooth Devices',0
	szErrorFormat 				db 'Error Control Code: %i',13,10,13,10,'%s',0
	szDevice 					db 'Device',0
	szNoDevice 					db 'No device(s) found',0
	szIrprops					db 'irprops.cpl',0
	
.code

start:
	
	Invoke LoadLibrary,Offset szIrprops
	mov hLib,eax
	invoke GetModuleHandle,NULL
	mov hInstance, eax	
	invoke DialogBoxParam,hInstance,IDD_MAIN,0,addr DlgProc,0
	Invoke FreeLibrary,hLib
	invoke ExitProcess,eax

DlgProc	proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	local icc:INITCOMMONCONTROLSEX
	
	.if uMsg == WM_INITDIALOG
		
		mov icc.dwICC, ICC_LISTVIEW_CLASSES or ICC_STANDARD_CLASSES		
		mov icc.dwSize, sizeof icc
		invoke InitCommonControlsEx,addr icc
		
		invoke GetDlgItem,hWin,IDC_LISTVIEW
		mov hList, eax
		invoke DoImageList ; --- add images
			
		invoke SendMessage,hList,LVM_SETIMAGELIST,LVSIL_SMALL,hImageList		
		invoke SendMessage,hList,LVM_ENABLEGROUPVIEW,TRUE,NULL
		
		; --- add list group with ID = 0 for device list
		invoke InsertGroupList,hList,offset szBluetooth,0
		; --- add colum to list view
		invoke InsertListColumn,hList,offset szDevice,300,0
		
		mov eax, hWin
		mov hDlg,eax
		
	.elseif uMsg == WM_COMMAND
		.if wParam == 1003			
			invoke FindDevices
		.endif
	.elseif uMsg == WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov eax, FALSE
		ret	
	.endif

	mov eax, TRUE
	Ret
DlgProc EndP


FindDevices proc
	
	local pbtsp:BLUETOOTH_DEVICE_SEARCH_PARAMS
	local pbtdi:BLUETOOTH_DEVICE_INFO
	
	invoke RtlZeroMemory,addr pbtdi, SizeOf pbtdi
	invoke RtlZeroMemory,addr pbtsp, SizeOf pbtsp
	
	mov pbtsp.dwSize, SizeOf pbtsp
	mov pbtsp.fReturnAuthenticated, TRUE
	mov pbtsp.fReturnRemembered, TRUE
	mov pbtsp.fReturnUnknown, TRUE
	mov pbtsp.fReturnConnected,TRUE
	mov pbtsp.fIssueInquiry,TRUE
	mov pbtsp.cTimeoutMultiplier, 60
	mov pbtsp.hRadio, NULL
	
	mov pbtdi.dwSize, SizeOf pbtdi
	
	invoke BluetoothFindFirstDevice,addr pbtsp, addr pbtdi
	
	.if eax != NULL ; --- device was found so add it to the list view
		mov hDevice, eax
		invoke InsertListItem,hList,addr szAppName,0,0,0 ; --- test only
	.else
		invoke ErrMsg,hDlg,1000,0
		invoke InsertListItem,hList,addr szNoDevice,0,0,0
	.endif
	
	invoke BluetoothFindDeviceClose,hDevice
	
	xor eax, eax
	Ret
FindDevices EndP


DoImageList proc
	
	Invoke ImageList_LoadImage, hInstance, ICO1, 16, 1, 0FFFFFFH, IMAGE_BITMAP, LR_CREATEDIBSECTION	
	mov hImageList, eax	
	
	xor eax, eax
	Ret
DoImageList EndP

ErrMsg proc hW:HWND, icode:DWORD, itype:DWORD
	
	local lbuffer:DWORD
	local mbuffer[256]:BYTE
	local dwError:DWORD
	
	.if itype == 0
		invoke GetLastError
	.elseif itype == 1
		;invoke WSAGetLastError
	.else
		invoke GetLastError
	.endif
	
	mov dwError,eax
	
	lea eax, [lbuffer]
	invoke FormatMessage,FORMAT_MESSAGE_ALLOCATE_BUFFER + FORMAT_MESSAGE_FROM_SYSTEM,0,[dwError],LANG_NEUTRAL,eax,0,0
	invoke wsprintf,addr mbuffer,addr szErrorFormat,icode,[lbuffer]
	invoke MessageBox,hW,addr mbuffer,addr szAppName,MB_ICONERROR+MB_OK
	invoke LocalFree,[lbuffer]
	
	xor eax, eax
	ret
ErrMsg endp

end start